package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamApplySiteTimeAddBo;
import com.zhongzheng.modules.exam.bo.ExamApplySiteTimeQueryBo;
import com.zhongzheng.modules.exam.bo.ExamApplySiteTimeEditBo;
import com.zhongzheng.modules.exam.domain.ExamApplySiteTime;
import com.zhongzheng.modules.exam.mapper.ExamApplySiteTimeMapper;
import com.zhongzheng.modules.exam.vo.ExamApplySiteTimeVo;
import com.zhongzheng.modules.exam.service.IExamApplySiteTimeService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 考试安排地点绑定时间Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-07
 */
@Service
public class ExamApplySiteTimeServiceImpl extends ServiceImpl<ExamApplySiteTimeMapper, ExamApplySiteTime> implements IExamApplySiteTimeService {

    @Override
    public ExamApplySiteTimeVo queryById(Long id){
        ExamApplySiteTime db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ExamApplySiteTimeVo.class);
    }

    @Override
    public List<ExamApplySiteTimeVo> queryList(ExamApplySiteTimeQueryBo bo) {
        LambdaQueryWrapper<ExamApplySiteTime> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getApplySiteId() != null, ExamApplySiteTime::getApplySiteId, bo.getApplySiteId());
        lqw.eq(StrUtil.isNotBlank(bo.getSiteTime()), ExamApplySiteTime::getSiteTime, bo.getSiteTime());
        lqw.eq(bo.getExamTime() != null, ExamApplySiteTime::getExamTime, bo.getExamTime());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamApplySiteTimeVo> entity2Vo(Collection<ExamApplySiteTime> collection) {
        List<ExamApplySiteTimeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamApplySiteTimeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamApplySiteTime> page = (Page<ExamApplySiteTime>)collection;
            Page<ExamApplySiteTimeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamApplySiteTimeAddBo bo) {
        ExamApplySiteTime add = BeanUtil.toBean(bo, ExamApplySiteTime.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamApplySiteTimeEditBo bo) {
        ExamApplySiteTime update = BeanUtil.toBean(bo, ExamApplySiteTime.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamApplySiteTime entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
